
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.5.4">
    
    
      
        <title>Papyrus UML support - Eclipse Hawk™</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.80dcb947.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
      

    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
<!-- FAVICON -->
<link rel="apple-touch-icon" sizes="180x180" href="../../assets/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="../../assets/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/favicon-16x16.png">
<link rel="mask-icon" href="../../assets/images/safari-pinned-tab.svg" color="#5bbad5">
<link rel="shortcut icon" href="../../assets/images/favicon.ico">
<meta name="msapplication-TileColor" content="#b91d47">
<meta name="msapplication-config" content="../../assets/images/browserconfig.xml">
<meta name="theme-color" content="#ffffff">

  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#supported-file-extensions" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="../.." title="Eclipse Hawk™" class="md-header__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Eclipse Hawk™
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Papyrus UML support
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
      </div>
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Eclipse Hawk™" class="md-nav__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    Eclipse Hawk™
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Home
      </a>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Basic use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Basic use" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Basic use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../installation/" class="md-nav__link">
        Installation
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../core-concepts/" class="md-nav__link">
        Core concepts
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../examples-xmi/" class="md-nav__link">
        Examples (XMI)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../examples-modelio/" class="md-nav__link">
        Examples (Modelio)
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Papyrus UML support
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Papyrus UML support
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#supported-file-extensions" class="md-nav__link">
    Supported file extensions
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#predefined-uml-packages" class="md-nav__link">
    Predefined UML packages
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#multi-version-papyrus-uml-profile-support" class="md-nav__link">
    Multi-version Papyrus UML profile support
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#example-using-hawk-to-index-all-uml-models-in-an-eclipse-workspace" class="md-nav__link">
    Example: using Hawk to index all UML models in an Eclipse workspace
  </a>
  
    <nav class="md-nav" aria-label="Example: using Hawk to index all UML models in an Eclipse workspace">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#models" class="md-nav__link">
    Models
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#creating-the-hawk-index" class="md-nav__link">
    Creating the Hawk index
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#adding-metamodels-and-models" class="md-nav__link">
    Adding metamodels and models
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#querying-hawk" class="md-nav__link">
    Querying Hawk
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#finding-uml-objects-by-stereotype" class="md-nav__link">
    Finding UML objects by stereotype
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#finding-stereotype-applications-from-the-uml-object" class="md-nav__link">
    Finding stereotype applications from the UML object
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Advanced use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Advanced use" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Advanced use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/graph-as-emf/" class="md-nav__link">
        Graph as EMF model
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/advanced-props/" class="md-nav__link">
        Advanced properties
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/meta-queries/" class="md-nav__link">
        Meta-level queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/temporal-queries/" class="md-nav__link">
        Temporal queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/oomph/" class="md-nav__link">
        Oomph and Hawk
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Server
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Server" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Server
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/architecture/" class="md-nav__link">
        Architecture
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api/" class="md-nav__link">
        Thrift API
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api-security/" class="md-nav__link">
        Thrift API security
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/deployment/" class="md-nav__link">
        Deployment
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/cli/" class="md-nav__link">
        Console client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/eclipse/" class="md-nav__link">
        Eclipse client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/other-languages/" class="md-nav__link">
        Cross-language clients
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/file-config/" class="md-nav__link">
        File-based configuration
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/logging/" class="md-nav__link">
        Logging
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Developers
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Developers" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Developers
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/run-from-source/" class="md-nav__link">
        Run GUI from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/server-from-source/" class="md-nav__link">
        Run Server from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/plain-maven/" class="md-nav__link">
        Build with plain Maven
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/website/" class="md-nav__link">
        Work on the website
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Community
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Community" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Community
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://www.eclipse.org/forums/index.php/f/442/" class="md-nav__link">
        Forum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues/new" class="md-nav__link">
        File a bug
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues" class="md-nav__link">
        Open bugs
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://ci.eclipse.org/hawk/" class="md-nav__link">
        Builds
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../../additional-resources/" class="md-nav__link">
        Additional resources
      </a>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#supported-file-extensions" class="md-nav__link">
    Supported file extensions
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#predefined-uml-packages" class="md-nav__link">
    Predefined UML packages
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#multi-version-papyrus-uml-profile-support" class="md-nav__link">
    Multi-version Papyrus UML profile support
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#example-using-hawk-to-index-all-uml-models-in-an-eclipse-workspace" class="md-nav__link">
    Example: using Hawk to index all UML models in an Eclipse workspace
  </a>
  
    <nav class="md-nav" aria-label="Example: using Hawk to index all UML models in an Eclipse workspace">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#models" class="md-nav__link">
    Models
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#creating-the-hawk-index" class="md-nav__link">
    Creating the Hawk index
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#adding-metamodels-and-models" class="md-nav__link">
    Adding metamodels and models
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#querying-hawk" class="md-nav__link">
    Querying Hawk
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#finding-uml-objects-by-stereotype" class="md-nav__link">
    Finding UML objects by stereotype
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#finding-stereotype-applications-from-the-uml-object" class="md-nav__link">
    Finding stereotype applications from the UML object
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  


  <h1>Papyrus UML support</h1>

<p>Hawk includes specific support for MDT2 UML models and UML profiles developed using Papyrus UML. This can be used by enabling the <code>UMLMetaModelResourceFactory</code> and <code>UMLModelResourceFactory</code> plugins when creating a Hawk instance.</p>
<p>The implementation mostly reuses MDT UML2 and Papyrus UML as-is, in order to maximize compatibility. There are some minor caveats, which are documented in this page.</p>
<h2 id="supported-file-extensions">Supported file extensions<a class="headerlink" href="#supported-file-extensions" title="Permanent link">&para;</a></h2>
<p>Hawk indexes plain UML2 models with the <code>.uml</code> extension, and Papyrus profiles with the <code>.profile.uml</code> extension. It does not index <code>.di</code> nor <code>.notation</code> files at the moment, as these do not provide semantic information.</p>
<p><code>.xmi</code> files are not indexed by the Hawk UML components, to avoid conflicts with the plain EMF support (matching the file to the proper model resource is done strictly by file extension). You are recommended to rename your UML2 XMI files to <code>.uml</code> for now.</p>
<h2 id="predefined-uml-packages">Predefined UML packages<a class="headerlink" href="#predefined-uml-packages" title="Permanent link">&para;</a></h2>
<p>UML2 provides an implementation of the UML standard libraries, with packages containing some common datatypes (e.g. String or Integer). If your models use any of these libraries, we heavily recommend that you add a <code>PredefinedUMLLibraries</code> component in your "Indexed Locations" section. Otherwise, any references from your models to the libraries will be left unresolved, and you will not be able to use those predefined entities in your queries.</p>
<p>This is because Hawk operates normally on files, and the predefined UML libraries are generally bundled within the UML2 plugins. The <code>PredefinedUMLLibraries</code> exposes those bundled resources to Hawk in a way that is transparent to the querying language.</p>
<h2 id="multi-version-papyrus-uml-profile-support">Multi-version Papyrus UML profile support<a class="headerlink" href="#multi-version-papyrus-uml-profile-support" title="Permanent link">&para;</a></h2>
<p>Beyond registering all the metamodels required to index plain UML models, the UML metamodel resource factory in Hawk can register <code>.profile.uml</code> files as metamodels. This allows us to index UML models with custom profiles in Hawk.</p>
<p>Since UML profiles can be versioned, Hawk will register version <code>X.Y.Z</code> of profile with URI <code>http://your/profile</code> with <code>http://your/profile/X.Y.Z</code> as the URI. When querying with Hawk, you will have to specify <code>http://your/profile/X.Y.Z</code> in your default namespaces, in order to resolve the ambiguity that may exist between multiple versions of the same metamodel.</p>
<p>If a new version of the UML profile is created, you will need to register the <code>.profile.uml</code> file again with Hawk before it can index models that use that version of the profile. Hawk treats entities of different versions of the same profile as entirely different types.</p>
<p>In terms of implementation details, Hawk takes advantage of the fact that <code>.profile.uml</code> files contain a collection of Ecore <code>EPackages</code>. Hawk simply adds the <code>/X.Y.Z</code> version suffix to their namespace URI, and otherwise leaves them untouched.</p>
<h2 id="example-using-hawk-to-index-all-uml-models-in-an-eclipse-workspace">Example: using Hawk to index all UML models in an Eclipse workspace<a class="headerlink" href="#example-using-hawk-to-index-all-uml-models-in-an-eclipse-workspace" title="Permanent link">&para;</a></h2>
<p>We will show how Hawk can be used to index all the UML models in an Eclipse workspace, including those that have custom profiles applied to them. To illustrate our approach, we will use <a href="../profiles/specialThings.zip">these toy models</a> created with Papyrus.</p>
<h3 id="models">Models<a class="headerlink" href="#models" title="Permanent link">&para;</a></h3>
<p>The model is a very simple UML class diagram:</p>
<p><img alt="Sample UML class diagram" src="../profiles/02-model.png" /></p>
<p>It only has two classes, one of which has the <code>&lt;&lt;Special&gt;&gt;</code> stereotype with a <code>priority</code> property equal to 23. This value is not shown in the diagram, but it can be checked from the "Profile" page of the "Properties" view when the class is selected.</p>
<p>The profile including the <code>&lt;&lt;Special&gt;&gt;</code> stereotype is also very simple:</p>
<p><img alt="Sample UML profile" src="../profiles/01-model.profile.png" /></p>
<p>The diagram imports the <code>Class</code> UML metaclass, and then extends it with the <code>&lt;&lt;Special&gt;&gt;</code> stereotype.</p>
<h3 id="creating-the-hawk-index">Creating the Hawk index<a class="headerlink" href="#creating-the-hawk-index" title="Permanent link">&para;</a></h3>
<p>Before we can run any queries, we need to create a Hawk index.
Please consult the <a href="../core-concepts/">core concepts</a> documentation on how to do this.
Some suggestions:</p>
<ul>
<li>"Local Hawk" instances are the easiest to use when learning Hawk.</li>
<li>You will not need time-awareness for this example.</li>
<li>The SQLite backend offers good all-round performance, especially for fragmented models.</li>
<li>It is best to disable all plugins, and then only enable the UML metamodel and model resource factories. We will only need the EOL query engine for this article.</li>
<li><code>Min/Max Delay</code> indicate how often will Hawk poll all the indexed locations. If you are only indexing the current workspace, you can leave both at 0 to disable polling: regardless of this setting, Hawk will react automatically whenever something in the workspace changes.</li>
</ul>
<p>Once the index has been created, you should see an entry for it in the "Hawk" view:</p>
<p><img alt="Hawk view with one instance" src="../profiles/03c-hawk-view.png" /></p>
<h3 id="adding-metamodels-and-models">Adding metamodels and models<a class="headerlink" href="#adding-metamodels-and-models" title="Permanent link">&para;</a></h3>
<p>From the screenshot above,  we know that the index is <code>RUNNING</code> (available for queries) and not <code>UPDATING</code> nor <code>STOPPED</code>, so we can start configuring it as we need. First, we should double click on it to open the configuration dialog:</p>
<p><img alt="Hawk index config dialog" src="../profiles/04-config-dialog.png" /></p>
<p>We should go to the "Metamodels" tab and click on "Add...", then select the <code>specialThings.profile/model.profile.uml</code> file. Hawk will register our custom profile as a metamodel, and we will be ready to index models using all the versions of this profile so far. Should we define any newer versions, we will have to add the file again to Hawk.</p>
<p>The dialog will now list the new metamodel:</p>
<p><img alt="Hawk index config dialog after registering profile" src="../profiles/05-added-metamodel.png" /></p>
<p>Now we are ready to add the locations where the models to be indexed are stored. We go to the "Indexed Locations" tab and click on "Add". First, we will add the predefined UML libraries with some commonly used instances (e.g. UML data types):</p>
<p><img alt="Adding UML predefined libraries" src="../profiles/06-add-predefinedlibs.png" /></p>
<p>We need to pick the right "Type", and then click OK.</p>
<p>Next, we have to tell Hawk to index all the models in the workspace. We will "Add" another location, and this time fill the dialog like this:</p>
<p><img alt="Adding workspace" src="../profiles/07-add-workspace.png" /></p>
<p>There are three variants of the workspace connector, using different sources of information for detecting if a file has changed.
Typically, the workspace timestamp tends to be the most reliable if all your changes are being performed from Eclipse.</p>
<p>Hawk will spend some time <code>UPDATING</code>, and once it is <code>RUNNING</code> again we will be ready to run some queries on it.</p>
<h3 id="querying-hawk">Querying Hawk<a class="headerlink" href="#querying-hawk" title="Permanent link">&para;</a></h3>
<p>We can finally query Hawk now. To do so, we need to select our index on the "Hawk" view and click on the "Query" button, which looks like a magnifying glass:</p>
<p><img alt="Query button in the Hawk view" src="../profiles/08a-hawk-query.png" /></p>
<p>We will see a dialog like this one, with all fields empty:</p>
<p><img alt="Query dialog" src="../profiles/08-query-classNames.png" /></p>
<p>Enter the query <code>return Class.all.name;</code> and click on the "Run Query" button. This query lists the names of all the classes indexed so far by Hawk. You will notice that we obtain these results:</p>
<div class="codehilite"><pre><span></span><code>[E, T, MyClass, Special, V, NotSoSpecial, Stereotype1, K, E]
</code></pre></div>

<p>The E/T/V/K/E classes came from the predefined UML libraries. If you want only the results from your workspace, you must tell Hawk through the "Context Repositories" field in the "Path-based scope" tab, by entering <code>platform:/resource</code>. This is the base URI used by Hawk to identify all the files in your workspace. Click on "Run Query" again, and you should obtain the results shown in the screenshot:</p>
<div class="codehilite"><pre><span></span><code>[MyClass, Stereotype1, Special, NotSoSpecial]
</code></pre></div>

<p>Note how the query also returns the classes in the profile. Should you want to avoid this, you can either use the "Context Files" field (<code>*model.uml</code> will do this) to further restrict the scope of the query.</p>
<h3 id="finding-uml-objects-by-stereotype">Finding UML objects by stereotype<a class="headerlink" href="#finding-uml-objects-by-stereotype" title="Permanent link">&para;</a></h3>
<p>If you would like to find all applications of stereotype <code>X</code>, you can simply use <code>X.all</code> and then use <code>base_Metaclass</code> to find the object that was annotated with that stereotype. For instance, this query will find the name of all the classes that had the <code>&lt;&lt;Special&gt;&gt;</code> stereotype applied to them:</p>
<div class="codehilite"><pre><span></span><code>return Special.all.base_Class.name;
</code></pre></div>

<p>You will get:</p>
<div class="codehilite"><pre><span></span><code>[MyClass]
</code></pre></div>

<p>You can also access stereotype properties:</p>
<div class="codehilite"><pre><span></span><code>return Special.all.collect(s|
  Sequence { s.priority, s.base_Class.name }
).asSequence;
</code></pre></div>

<p>This will produce:</p>
<div class="codehilite"><pre><span></span><code>[[23, MyClass]]
</code></pre></div>

<h3 id="finding-stereotype-applications-from-the-uml-object">Finding stereotype applications from the UML object<a class="headerlink" href="#finding-stereotype-applications-from-the-uml-object" title="Permanent link">&para;</a></h3>
<p>If you want to go the other way around, you can use reverse reference navigation on those <code>base_X</code> references to find the stereotypes that have been applied to a UML object:</p>
<div class="codehilite"><pre><span></span><code>return Class.all
  .selectOne(s|s.name = &#39;MyClass&#39;)
  .revRefNav_base_Class
  .collect(st|Model.getTypeOf(st))
  .name;
</code></pre></div>

<p>This would produce:</p>
<div class="codehilite"><pre><span></span><code>[Special]
</code></pre></div>





                
              </article>
            </div>
          
          
        </div>
        
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../examples-modelio/" title="Examples (Modelio)" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Examples (Modelio)
              </span>
            </div>
          </a>
        
        
          <a href="../../advanced-use/graph-as-emf/" title="Graph as EMF model" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Graph as EMF model
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            Copyright © Eclipse Foundation, Inc. All Rights Reserved.
          </div>
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">Material for MkDocs</a>
      </div>
      <div class="md-footer-copyright hawk-eclipse-links">
          <ul>
              <li><a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a></li>
              <li><a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a></li>
              <li><a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a></li>
          </ul>
      </div>
      <div class="md-social">
  
</div>
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    <script id="__config" type="application/json">{"base": "../..", "features": [], "search": "../../assets/javascripts/workers/search.5bf1dace.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version.title": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.078830c0.min.js"></script>
      
    
  </body>
</html>